Index: MediaWiki/branches/1.11/includes/api/ApiQuerySiteinfo.php
===================================================================
--- MediaWiki/branches/1.11/includes/api/ApiQuerySiteinfo.php	(revision 1280)
+++ MediaWiki/branches/1.11/includes/api/ApiQuerySiteinfo.php	(revision 1281)
@@ -6,5 +6,5 @@
  * API for MediaWiki 1.8+
  *
- * Copyright (C) 2006 Yuri Astrakhan <FirstnameLastname@gmail.com>
+ * Copyright (C) 2006 Yuri Astrakhan <Firstname><Lastname>@gmail.com
  *
  * This program is free software; you can redistribute it and/or modify
@@ -30,4 +30,6 @@
 
 /**
+ * A query action to return meta information about the wiki site.
+ * 
  * @addtogroup API
  */
@@ -39,48 +41,144 @@
 
 	public function execute() {
-		$prop = null;
-		extract($this->extractRequestParams());
-
-		foreach ($prop as $p) {
+
+		$params = $this->extractRequestParams();
+
+		foreach ($params['prop'] as $p) {
 			switch ($p) {
-
-				case 'general' :
-
-					global $wgSitename, $wgVersion, $wgCapitalLinks, $wgRightsCode, $wgRightsText;
-					$data = array ();
-					$mainPage = Title :: newFromText(wfMsgForContent('mainpage'));
-					$data['mainpage'] = $mainPage->getText();
-					$data['base'] = $mainPage->getFullUrl();
-					$data['sitename'] = $wgSitename;
-					$data['generator'] = "MediaWiki $wgVersion";
-					$data['case'] = $wgCapitalLinks ? 'first-letter' : 'case-sensitive'; // 'case-insensitive' option is reserved for future
-					if (isset($wgRightsCode))
-						$data['rightscode'] = $wgRightsCode;
-					$data['rights'] = $wgRightsText;
-					$this->getResult()->addValue('query', $p, $data);
-					break;
-
-				case 'namespaces' :
-
-					global $wgContLang;
-					$data = array ();
-					foreach ($wgContLang->getFormattedNamespaces() as $ns => $title) {
-						$data[$ns] = array (
-							'id' => $ns
-						);
-						ApiResult :: setContent($data[$ns], $title);
-					}
-					$this->getResult()->setIndexedTagName($data, 'ns');
-					$this->getResult()->addValue('query', $p, $data);
-					break;
-					
 				default :
 					ApiBase :: dieDebug(__METHOD__, "Unknown prop=$p");
+				case 'general' :
+					$this->appendGeneralInfo($p);
+					break;
+				case 'namespaces' :
+					$this->appendNamespaces($p);
+					break;
+				case 'interwikimap' :
+					$filteriw = isset($params['filteriw']) ? $params['filteriw'] : false; 
+					$this->appendInterwikiMap($p, $filteriw);
+					break;
+				case 'dbrepllag' :
+					$this->appendDbReplLagInfo($p, $params['showalldb']);
+					break;
+				case 'statistics' :
+					$this->appendStatistics($p);
+					break;
 			}
 		}
 	}
 
+	protected function appendGeneralInfo($property) {
+		global $wgSitename, $wgVersion, $wgCapitalLinks, $wgRightsCode, $wgRightsText, $wgLanguageCode;
+		
+		$data = array ();
+		$mainPage = Title :: newFromText(wfMsgForContent('mainpage'));
+		$data['mainpage'] = $mainPage->getText();
+		$data['base'] = $mainPage->getFullUrl();
+		$data['sitename'] = $wgSitename;
+		$data['generator'] = "MediaWiki $wgVersion";
+		$data['case'] = $wgCapitalLinks ? 'first-letter' : 'case-sensitive'; // 'case-insensitive' option is reserved for future
+		if (isset($wgRightsCode))
+			$data['rightscode'] = $wgRightsCode;
+		$data['rights'] = $wgRightsText;
+		$data['lang'] = $wgLanguageCode;
+		
+		$this->getResult()->addValue('query', $property, $data);
+	}
+	
+	protected function appendNamespaces($property) {
+		global $wgContLang;
+		
+		$data = array ();
+		foreach ($wgContLang->getFormattedNamespaces() as $ns => $title) {
+			$data[$ns] = array (
+				'id' => $ns
+			);
+			ApiResult :: setContent($data[$ns], $title);
+		}
+		
+		$this->getResult()->setIndexedTagName($data, 'ns');
+		$this->getResult()->addValue('query', $property, $data);
+	}
+	
+	protected function appendInterwikiMap($property, $filter) {
+
+		$this->resetQueryParams();
+		$this->addTables('interwiki');
+		$this->addFields(array('iw_prefix', 'iw_local', 'iw_url'));
+
+		if($filter === 'local') {
+			$this->addWhere('iw_local = 1');
+		} elseif($filter === '!local') {
+			$this->addWhere('iw_local = 0');
+		} elseif($filter !== false) {
+			ApiBase :: dieDebug(__METHOD__, "Unknown filter=$filter");
+		}
+
+		$this->addOption('ORDER BY', 'iw_prefix');
+		
+		$db = $this->getDB();
+		$res = $this->select(__METHOD__);
+
+		$data = array();
+		while($row = $db->fetchObject($res))
+		{
+			$val['prefix'] = $row->iw_prefix;
+			if ($row->iw_local == '1')
+				$val['local'] = '';
+//			$val['trans'] = intval($row->iw_trans);	// should this be exposed?
+			$val['url'] = $row->iw_url;
+				
+			$data[] = $val;
+		}
+		$db->freeResult($res);
+		
+		$this->getResult()->setIndexedTagName($data, 'iw');
+		$this->getResult()->addValue('query', $property, $data);
+	}
+	
+	protected function appendDbReplLagInfo($property, $includeAll) {
+		global $wgLoadBalancer, $wgShowHostnames;
+
+		$data = array();
+		
+		if ($includeAll) {
+			if (!$wgShowHostnames)
+				$this->dieUsage('Cannot view all servers info unless $wgShowHostnames is true', 'includeAllDenied');
+			
+			global $wgDBservers;
+			$lags = $wgLoadBalancer->getLagTimes();
+			foreach( $lags as $i => $lag ) {
+				$data[] = array (
+					'host' => $wgDBservers[$i]['host'],
+					'lag' => $lag);
+			}
+		} else {
+			list( $host, $lag ) = $wgLoadBalancer->getMaxLag();
+			$data[] = array (
+				'host' => $wgShowHostnames ? $host : '',
+				'lag' => $lag);
+		}					
+
+		$result = $this->getResult();
+		$result->setIndexedTagName($data, 'db');
+		$result->addValue('query', $property, $data);
+	}	
+
+	protected function appendStatistics($property) {
+		$data = array ();
+		$data['pages'] = intval(SiteStats::pages());
+		$data['articles'] = intval(SiteStats::articles());
+		$data['views'] = intval(SiteStats::views());
+		$data['edits'] = intval(SiteStats::edits());
+		$data['images'] = intval(SiteStats::images());
+		$data['users'] = intval(SiteStats::users());
+		$data['admins'] = intval(SiteStats::admins());
+		$data['jobs'] = intval(SiteStats::jobs());
+		$this->getResult()->addValue('query', $property, $data);
+	}	
+	
 	protected function getAllowedParams() {
 		return array (
+		
 			'prop' => array (
 				ApiBase :: PARAM_DFLT => 'general',
@@ -88,7 +186,17 @@
 				ApiBase :: PARAM_TYPE => array (
 					'general',
-					'namespaces'
-				)
-			)
+					'namespaces',
+					'interwikimap',
+					'dbrepllag',
+					'statistics',
+				)),
+
+			'filteriw' => array (
+				ApiBase :: PARAM_TYPE => array (
+					'local',
+					'!local',
+				)),
+				
+			'showalldb' => false,
 		);
 	}
@@ -98,7 +206,12 @@
 			'prop' => array (
 				'Which sysinfo properties to get:',
-				' "general"    - Overall system information',
-				' "namespaces" - List of registered namespaces (localized)'
-			)
+				' "general"      - Overall system information',
+				' "namespaces"   - List of registered namespaces (localized)',
+				' "statistics"   - Returns site statistics',
+				' "interwikimap" - Returns interwiki map (optionally filtered)',
+				' "dbrepllag"    - Returns database server with the highest replication lag',
+			),
+			'filteriw' =>  'Return only local or only nonlocal entries of the interwiki map',
+			'showalldb' => 'List all database servers, not just the one lagging the most',
 		);
 	}
@@ -109,10 +222,13 @@
 
 	protected function getExamples() {
-		return 'api.php?action=query&meta=siteinfo&siprop=general|namespaces';
+		return array(
+			'api.php?action=query&meta=siteinfo&siprop=general|namespaces|statistics',
+			'api.php?action=query&meta=siteinfo&siprop=interwikimap&sifilteriw=local',
+			'api.php?action=query&meta=siteinfo&siprop=dbrepllag&sishowalldb',
+			);
 	}
 
 	public function getVersion() {
-		return __CLASS__ . ': $Id: ApiQuerySiteinfo.php 21402 2007-04-20 08:55:14Z nickj $';
+		return __CLASS__ . ': $Id: ApiQuerySiteinfo.php 25238 2007-08-28 15:37:31Z robchurch $';
 	}
 }
-?>
